<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::ComponentPath Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1ComponentPath.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1ComponentPath-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::ComponentPath Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A representation of a path within a <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> tree.  
 <a href="classOpenSim_1_1ComponentPath.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a28495dfc0284603bbfc11f1c2d810ade"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a28495dfc0284603bbfc11f1c2d810ade">ComponentPath</a> ()</td></tr>
<tr class="memdesc:a28495dfc0284603bbfc11f1c2d810ade"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor that constructs an empty path ("").  <a href="classOpenSim_1_1ComponentPath.html#a28495dfc0284603bbfc11f1c2d810ade">More...</a><br /></td></tr>
<tr class="separator:a28495dfc0284603bbfc11f1c2d810ade"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04c62d0ec148c8f6c03b362edd56636d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a04c62d0ec148c8f6c03b362edd56636d">ComponentPath</a> (std::string path)</td></tr>
<tr class="memdesc:a04c62d0ec148c8f6c03b362edd56636d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> from a path string (e.g.  <a href="classOpenSim_1_1ComponentPath.html#a04c62d0ec148c8f6c03b362edd56636d">More...</a><br /></td></tr>
<tr class="separator:a04c62d0ec148c8f6c03b362edd56636d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa65e676dd975f6507a87e0adb7202c0e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#aa65e676dd975f6507a87e0adb7202c0e">ComponentPath</a> (const std::vector&lt; std::string &gt; &amp;pathVec, bool <a class="el" href="classOpenSim_1_1ComponentPath.html#a023ec59bf5dc4ccf302b1f2d05696f5f">isAbsolute</a>)</td></tr>
<tr class="memdesc:aa65e676dd975f6507a87e0adb7202c0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> from a vector of its elements.  <a href="classOpenSim_1_1ComponentPath.html#aa65e676dd975f6507a87e0adb7202c0e">More...</a><br /></td></tr>
<tr class="separator:aa65e676dd975f6507a87e0adb7202c0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9b323e0139e41802e46d253a2df5244"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#ad9b323e0139e41802e46d253a2df5244">operator==</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;) const</td></tr>
<tr class="separator:ad9b323e0139e41802e46d253a2df5244"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8958e6054b5892bfbb016100c8f791ab"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a8958e6054b5892bfbb016100c8f791ab">operator!=</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;) const</td></tr>
<tr class="separator:a8958e6054b5892bfbb016100c8f791ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab607f7a30ebf2133f12371b96a748c8f"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#ab607f7a30ebf2133f12371b96a748c8f">getSeparator</a> () const</td></tr>
<tr class="separator:ab607f7a30ebf2133f12371b96a748c8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49f2a55af389be606e56a86e5df7e947"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a49f2a55af389be606e56a86e5df7e947">getInvalidChars</a> () const</td></tr>
<tr class="memdesc:a49f2a55af389be606e56a86e5df7e947"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a string containing a sequence of all invalid characters.  <a href="classOpenSim_1_1ComponentPath.html#a49f2a55af389be606e56a86e5df7e947">More...</a><br /></td></tr>
<tr class="separator:a49f2a55af389be606e56a86e5df7e947"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac73cba6e7abac767e022023d0c3e8c4b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#ac73cba6e7abac767e022023d0c3e8c4b">formAbsolutePath</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;otherPath) const</td></tr>
<tr class="memdesc:ac73cba6e7abac767e022023d0c3e8c4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a path that is the result of resolving <code>this</code> from <code>otherPath</code>.  <a href="classOpenSim_1_1ComponentPath.html#ac73cba6e7abac767e022023d0c3e8c4b">More...</a><br /></td></tr>
<tr class="separator:ac73cba6e7abac767e022023d0c3e8c4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1dc8cd402b746925e7894ef53bdbe5e3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a1dc8cd402b746925e7894ef53bdbe5e3">formRelativePath</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;otherPath) const</td></tr>
<tr class="memdesc:a1dc8cd402b746925e7894ef53bdbe5e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the relative Path between this Path and another Path (otherPath) (i.e.  <a href="classOpenSim_1_1ComponentPath.html#a1dc8cd402b746925e7894ef53bdbe5e3">More...</a><br /></td></tr>
<tr class="separator:a1dc8cd402b746925e7894ef53bdbe5e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ea7411e951a4e0c8f5c8f8a9999d9c2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a2ea7411e951a4e0c8f5c8f8a9999d9c2">getParentPath</a> () const</td></tr>
<tr class="memdesc:a2ea7411e951a4e0c8f5c8f8a9999d9c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the sub-path that contains all subdirectory levels except for the last one.  <a href="classOpenSim_1_1ComponentPath.html#a2ea7411e951a4e0c8f5c8f8a9999d9c2">More...</a><br /></td></tr>
<tr class="separator:a2ea7411e951a4e0c8f5c8f8a9999d9c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43a4373b1463fcdf3ba2e8267e72ea4b"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a43a4373b1463fcdf3ba2e8267e72ea4b">getParentPathString</a> () const</td></tr>
<tr class="memdesc:a43a4373b1463fcdf3ba2e8267e72ea4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the parent path as a string.  <a href="classOpenSim_1_1ComponentPath.html#a43a4373b1463fcdf3ba2e8267e72ea4b">More...</a><br /></td></tr>
<tr class="separator:a43a4373b1463fcdf3ba2e8267e72ea4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3b216b7291edc20f6ee0fb06fda9788"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#af3b216b7291edc20f6ee0fb06fda9788">getSubcomponentNameAtLevel</a> (size_t index) const</td></tr>
<tr class="memdesc:af3b216b7291edc20f6ee0fb06fda9788"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the name of a subdirectory in the path at the specified level (0-indexed).  <a href="classOpenSim_1_1ComponentPath.html#af3b216b7291edc20f6ee0fb06fda9788">More...</a><br /></td></tr>
<tr class="separator:af3b216b7291edc20f6ee0fb06fda9788"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a793760fbbdea7d2d44001b14ea900d7e"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a793760fbbdea7d2d44001b14ea900d7e">getComponentName</a> () const</td></tr>
<tr class="memdesc:a793760fbbdea7d2d44001b14ea900d7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the name of the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> in the path (effectively, the last element in the path).  <a href="classOpenSim_1_1ComponentPath.html#a793760fbbdea7d2d44001b14ea900d7e">More...</a><br /></td></tr>
<tr class="separator:a793760fbbdea7d2d44001b14ea900d7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a465df0b4170dd05426f0f69572ca4d99"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a465df0b4170dd05426f0f69572ca4d99">toString</a> () const</td></tr>
<tr class="memdesc:a465df0b4170dd05426f0f69572ca4d99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a string representation of the <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> (e.g.  <a href="classOpenSim_1_1ComponentPath.html#a465df0b4170dd05426f0f69572ca4d99">More...</a><br /></td></tr>
<tr class="separator:a465df0b4170dd05426f0f69572ca4d99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a023ec59bf5dc4ccf302b1f2d05696f5f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a023ec59bf5dc4ccf302b1f2d05696f5f">isAbsolute</a> () const</td></tr>
<tr class="memdesc:a023ec59bf5dc4ccf302b1f2d05696f5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if the path is absolute (effectively, if it begins with '/').  <a href="classOpenSim_1_1ComponentPath.html#a023ec59bf5dc4ccf302b1f2d05696f5f">More...</a><br /></td></tr>
<tr class="separator:a023ec59bf5dc4ccf302b1f2d05696f5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85fde6c4e026fca2d6dafc22755698db"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a85fde6c4e026fca2d6dafc22755698db">getNumPathLevels</a> () const</td></tr>
<tr class="memdesc:a85fde6c4e026fca2d6dafc22755698db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of levels in the path (e.g.  <a href="classOpenSim_1_1ComponentPath.html#a85fde6c4e026fca2d6dafc22755698db">More...</a><br /></td></tr>
<tr class="separator:a85fde6c4e026fca2d6dafc22755698db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20d6325b9f17a5940ea7ef26901f9808"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a20d6325b9f17a5940ea7ef26901f9808">pushBack</a> (const std::string &amp;pathElement)</td></tr>
<tr class="memdesc:a20d6325b9f17a5940ea7ef26901f9808"><td class="mdescLeft">&#160;</td><td class="mdescRight">Push a string onto the end of the path.  <a href="classOpenSim_1_1ComponentPath.html#a20d6325b9f17a5940ea7ef26901f9808">More...</a><br /></td></tr>
<tr class="separator:a20d6325b9f17a5940ea7ef26901f9808"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6fd86ff7a3bf04446b7be2edafbfd32"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#ab6fd86ff7a3bf04446b7be2edafbfd32">isLegalPathElement</a> (const std::string &amp;pathElement) const</td></tr>
<tr class="memdesc:ab6fd86ff7a3bf04446b7be2edafbfd32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if the argument does not contain any invalid characters.  <a href="classOpenSim_1_1ComponentPath.html#ab6fd86ff7a3bf04446b7be2edafbfd32">More...</a><br /></td></tr>
<tr class="separator:ab6fd86ff7a3bf04446b7be2edafbfd32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b943f06ca3e806ffd3a926912b0a9e4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ComponentPath.html#a9b943f06ca3e806ffd3a926912b0a9e4">trimDotAndDotDotElements</a> ()</td></tr>
<tr class="memdesc:a9b943f06ca3e806ffd3a926912b0a9e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolves '.  <a href="classOpenSim_1_1ComponentPath.html#a9b943f06ca3e806ffd3a926912b0a9e4">More...</a><br /></td></tr>
<tr class="separator:a9b943f06ca3e806ffd3a926912b0a9e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>A representation of a path within a <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> tree. </p>
<p>This class is effectively a wrapper around a normalized path string. A path string is a sequence of path elements interspersed with '/' as a separator. path elements cannot contain:</p>
<ul>
<li>back-slash ('\')</li>
<li>forward-slash ('/')</li>
<li>asterisk ('*')</li>
<li>plus-sign ('+')</li>
</ul>
<p>An empty path, "", is allowed. Adjacent separators in a path (e.g. "//") are combined into one separator.</p>
<dl class="section author"><dt>Author</dt><dd>Carmichael Ong </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a28495dfc0284603bbfc11f1c2d810ade"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28495dfc0284603bbfc11f1c2d810ade">&#9670;&nbsp;</a></span>ComponentPath() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::ComponentPath::ComponentPath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Default constructor that constructs an empty path (""). </p>

</div>
</div>
<a id="a04c62d0ec148c8f6c03b362edd56636d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04c62d0ec148c8f6c03b362edd56636d">&#9670;&nbsp;</a></span>ComponentPath() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::ComponentPath::ComponentPath </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>path</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> from a path string (e.g. </p>
<p>"/a/b/component"). </p>

</div>
</div>
<a id="aa65e676dd975f6507a87e0adb7202c0e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa65e676dd975f6507a87e0adb7202c0e">&#9670;&nbsp;</a></span>ComponentPath() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::ComponentPath::ComponentPath </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>pathVec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isAbsolute</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> from a vector of its elements. </p>
<p>Throws if any element in <code>pathVec</code> contains an invalid character. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ac73cba6e7abac767e022023d0c3e8c4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac73cba6e7abac767e022023d0c3e8c4b">&#9670;&nbsp;</a></span>formAbsolutePath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> OpenSim::ComponentPath::formAbsolutePath </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;&#160;</td>
          <td class="paramname"><em>otherPath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a path that is the result of resolving <code>this</code> from <code>otherPath</code>. </p>
<ul>
<li><code>otherPath</code> must be an absolute path; otherwise, an exception will be thrown</li>
<li>if <code>this</code> is absolute, then this function just returns a copy of <code>this</code></li>
</ul>
<p>Examples: </p><pre class="fragment">ComponentPath{"b/c"}.formAbsolutePath("/a") == "/a/b/c"
ComponentPath{"/b/c"}.formAbsolutePath("/a") == "/b/c"
ComponentPath{"b/c"}.formAbsolutePath("a")  // throws
</pre> 
</div>
</div>
<a id="a1dc8cd402b746925e7894ef53bdbe5e3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1dc8cd402b746925e7894ef53bdbe5e3">&#9670;&nbsp;</a></span>formRelativePath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> OpenSim::ComponentPath::formRelativePath </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;&#160;</td>
          <td class="paramname"><em>otherPath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Find the relative Path between this Path and another Path (otherPath) (i.e. </p>
<p>the Path to go FROM otherPath TO this Path). Both Paths must be absolute. </p>

</div>
</div>
<a id="a793760fbbdea7d2d44001b14ea900d7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a793760fbbdea7d2d44001b14ea900d7e">&#9670;&nbsp;</a></span>getComponentName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string OpenSim::ComponentPath::getComponentName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the name of the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> in the path (effectively, the last element in the path). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1AbstractSocket.html#aa9f59a8fb706f130a3681271443db16e">OpenSim::AbstractSocket::checkConnecteePathProperty()</a>.</p>

</div>
</div>
<a id="a49f2a55af389be606e56a86e5df7e947"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49f2a55af389be606e56a86e5df7e947">&#9670;&nbsp;</a></span>getInvalidChars()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; OpenSim::ComponentPath::getInvalidChars </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a string containing a sequence of all invalid characters. </p>

</div>
</div>
<a id="a85fde6c4e026fca2d6dafc22755698db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85fde6c4e026fca2d6dafc22755698db">&#9670;&nbsp;</a></span>getNumPathLevels()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t OpenSim::ComponentPath::getNumPathLevels </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the number of levels in the path (e.g. </p>
<p>"/a/b/c" == 3). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">OpenSim::Socket&lt; T &gt;::finalizeConnection()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">OpenSim::Input&lt; T &gt;::finalizeConnection()</a>.</p>

</div>
</div>
<a id="a2ea7411e951a4e0c8f5c8f8a9999d9c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ea7411e951a4e0c8f5c8f8a9999d9c2">&#9670;&nbsp;</a></span>getParentPath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> OpenSim::ComponentPath::getParentPath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the sub-path that contains all subdirectory levels except for the last one. </p>

</div>
</div>
<a id="a43a4373b1463fcdf3ba2e8267e72ea4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43a4373b1463fcdf3ba2e8267e72ea4b">&#9670;&nbsp;</a></span>getParentPathString()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string OpenSim::ComponentPath::getParentPathString </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the parent path as a string. </p>

</div>
</div>
<a id="ab607f7a30ebf2133f12371b96a748c8f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab607f7a30ebf2133f12371b96a748c8f">&#9670;&nbsp;</a></span>getSeparator()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char OpenSim::ComponentPath::getSeparator </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="af3b216b7291edc20f6ee0fb06fda9788"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af3b216b7291edc20f6ee0fb06fda9788">&#9670;&nbsp;</a></span>getSubcomponentNameAtLevel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string OpenSim::ComponentPath::getSubcomponentNameAtLevel </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the name of a subdirectory in the path at the specified level (0-indexed). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">OpenSim::Socket&lt; T &gt;::finalizeConnection()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">OpenSim::Input&lt; T &gt;::finalizeConnection()</a>.</p>

</div>
</div>
<a id="a023ec59bf5dc4ccf302b1f2d05696f5f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a023ec59bf5dc4ccf302b1f2d05696f5f">&#9670;&nbsp;</a></span>isAbsolute()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool OpenSim::ComponentPath::isAbsolute </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns true if the path is absolute (effectively, if it begins with '/'). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">OpenSim::Socket&lt; T &gt;::finalizeConnection()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">OpenSim::Input&lt; T &gt;::finalizeConnection()</a>.</p>

</div>
</div>
<a id="ab6fd86ff7a3bf04446b7be2edafbfd32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab6fd86ff7a3bf04446b7be2edafbfd32">&#9670;&nbsp;</a></span>isLegalPathElement()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool OpenSim::ComponentPath::isLegalPathElement </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>pathElement</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns true if the argument does not contain any invalid characters. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1AbstractSocket.html#aa9f59a8fb706f130a3681271443db16e">OpenSim::AbstractSocket::checkConnecteePathProperty()</a>.</p>

</div>
</div>
<a id="a8958e6054b5892bfbb016100c8f791ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8958e6054b5892bfbb016100c8f791ab">&#9670;&nbsp;</a></span>operator!=()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool OpenSim::ComponentPath::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ad9b323e0139e41802e46d253a2df5244"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad9b323e0139e41802e46d253a2df5244">&#9670;&nbsp;</a></span>operator==()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool OpenSim::ComponentPath::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a20d6325b9f17a5940ea7ef26901f9808"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a20d6325b9f17a5940ea7ef26901f9808">&#9670;&nbsp;</a></span>pushBack()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::ComponentPath::pushBack </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>pathElement</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Push a string onto the end of the path. </p>
<p>Throws if the argument contains invalid characters. </p>

</div>
</div>
<a id="a465df0b4170dd05426f0f69572ca4d99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a465df0b4170dd05426f0f69572ca4d99">&#9670;&nbsp;</a></span>toString()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; OpenSim::ComponentPath::toString </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a string representation of the <a class="el" href="classOpenSim_1_1ComponentPath.html" title="A representation of a path within a Component tree.">ComponentPath</a> (e.g. </p>
<p>"/a/b/component"). </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Socket.html#a78d4f73ee2cbba0e3052463d71017367">OpenSim::Socket&lt; T &gt;::finalizeConnection()</a>, <a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">OpenSim::Input&lt; T &gt;::finalizeConnection()</a>, and <a class="el" href="classOpenSim_1_1Socket.html#accb8a43c9bc42c12d37d80836ece8de4">OpenSim::Socket&lt; T &gt;::findAndConnect()</a>.</p>

</div>
</div>
<a id="a9b943f06ca3e806ffd3a926912b0a9e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b943f06ca3e806ffd3a926912b0a9e4">&#9670;&nbsp;</a></span>trimDotAndDotDotElements()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::ComponentPath::trimDotAndDotDotElements </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Resolves '. </p>
<p>' and ".." elements in the path if possible. Leading ".." elements are allowed only in relative paths (throws if found at the start of an absolute path). Also checks for invalid characters.</p>
<p>Effectively, this is the same as internally <code>normalize</code>ing the path. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/ComponentPath.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:42 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
